package com.yihu.jw.basic.agadmin.controller.quota;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.yihu.jw.basic.quota.service.TjDataSaveService;
import com.yihu.jw.entity.ehr.quota.TjDataSave;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.util.http.HttpClientUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.ui.Model;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.net.URLDecoder;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by llh on 2017/5/9.
 */
@RestController
@RequestMapping("/tjDataSave")
public class TjDataSaveController extends EnvelopRestEndpoint {

    @Autowired
    TjDataSaveService tjDataSaveService;

    //查询统计主维度
    @GetMapping("/getTjDataSave")
    public Envelop searchTjDataSave(String name, String searchParm,int page, int rows){
        String url = "/tj/getTjDataSaveList";
        String resultStr = "";
        Envelop envelop = new Envelop();
        Map<String, Object> params = new HashMap<>();
        StringBuffer stringBuffer = new StringBuffer();
        if (!StringUtils.isEmpty(name)) {
            stringBuffer.append("name?" + name );
        }
        if (!StringUtils.isEmpty(searchParm)) {
            stringBuffer.append("name?" + searchParm );
        }
        String filters = stringBuffer.toString();
        try {
            PageEnvelop PageEnvelop = new PageEnvelop();
            List<TjDataSave> tjDataSaveList = tjDataSaveService.search(null, filters, null, page, rows);
            if(tjDataSaveList != null){
                PageEnvelop.setDetailModelList(tjDataSaveList);
                PageEnvelop.setTotalCount((int)tjDataSaveService.getCount(filters));
                PageEnvelop.setStatus(200);
                PageEnvelop.setCurrPage(page);
                PageEnvelop.setPageSize(rows);
            }else{
                PageEnvelop.setStatus(200);
                PageEnvelop.setMessage("查询无数据");
                PageEnvelop.setTotalCount(0);
            }
            return PageEnvelop;
        } catch (Exception ex) {
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }



    /**
     * 新增修改
     * @param tjDataSaveModelJsonData
     * @param request
     * @return
     * @throws IOException
     */
    @RequestMapping(value = "updateTjDataSave", produces = "text/html;charset=UTF-8")
    public Envelop updateTjDataSave(String tjDataSaveModelJsonData, HttpServletRequest request) throws IOException {

        String url = "/tj/addTjDataSave";
        String resultStr = "";
        System.out.println();
        Envelop result = new Envelop();
        String[] strings = URLDecoder.decode(tjDataSaveModelJsonData, "UTF-8").split(";");
        try {
            TjDataSave detailModel = objectMapper.readValue(strings[0], TjDataSave.class);

            if (!StringUtils.isEmpty(detailModel.getId())) {
                Long tjDataSaveId = detailModel.getId();
                TjDataSave updateTjDataSave = tjDataSaveService.getById(tjDataSaveId);
                if (updateTjDataSave !=null ) {
                    updateTjDataSave.setCode(detailModel.getCode());
                    updateTjDataSave.setName(detailModel.getName());
                    updateTjDataSave.setType(detailModel.getType());
                    updateTjDataSave.setStatus(detailModel.getStatus());
                    updateTjDataSave.setRemark(detailModel.getRemark());

                    updateTjDataSave.setUpdateTime(new Date());
                    tjDataSaveService.save(updateTjDataSave);
                    return ObjEnvelop.getSuccess("保存成功！", updateTjDataSave);
                } else {
                    return failed("参数错误");
                }
            } else {
                detailModel.setCreateTime(new Date());
                tjDataSaveService.save(detailModel);
                return ObjEnvelop.getSuccess("保存成功",detailModel);
            }
        } catch (Exception e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    /**
     * 删除消息
     * @param tjDataSaveId
     * @return
     */
    @RequestMapping("deleteTjDataSave")
    public Envelop deleteTjDataSave(Long tjDataSaveId) {
        String url = "/tj/deleteTjDataSave";
        try {
            TjDataSave tjDataSave = tjDataSaveService.getById(tjDataSaveId);
            tjDataSave.setStatus(-1);
            tjDataSaveService.save(tjDataSave);
            return success("删除成功");
        } catch (Exception e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    /**
     * 根据id获取消息
     * @param id
     * @return
     */
    @GetMapping("getTjDataSaveById")
    public Envelop getTjQuotaById(Long id ) {
        String url ="/tj/getTjDataSaveById/" +id;
        try {
            TjDataSave updateTjDataSave = tjDataSaveService.getById(id);
            return ObjEnvelop.getSuccess("获取成功",updateTjDataSave);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return failed("查询失败");

    }

    /**
     * 校验name是否唯一,true已存在
     * @param name
     * @return
     */
    @GetMapping("hasExistsName")
    public Envelop hasExistsName(String name) {
        String url = "/tj/dataSaveExistsName/"+ name ;
        try {
            String filter = "name=" + name;
            List<TjDataSave> list = tjDataSaveService.search(filter);
            return ObjEnvelop.getSuccess("查询成功",list.size() > 0);
        } catch (Exception e) {
            e.getMessage();
        }
        return  failed("查询失败");
    }

    /**
     * 校验code是否唯一
     * @param code
     * @return
     */
    @GetMapping("hasExistsCode")
    public Envelop hasExistsCode(String code) {
        String url = "/tj/dataSaveExistsCode/" + code ;
        try {
            String filter = "code=" + code;
            List<TjDataSave> list = tjDataSaveService.search(filter);
            return ObjEnvelop.getSuccess("查询成功",list.size() > 0);
        } catch (Exception e) {
            e.getMessage();
        }
        return  failed("查询失败");
    }
}
