package com.yihu.jw.basic.agadmin.controller.quota;

import com.fasterxml.jackson.databind.ObjectMapper;

import com.yihu.jw.basic.quota.service.TjDimensionMainService;
import com.yihu.jw.entity.ehr.quota.TjDimensionMain;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.util.http.HttpClientUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.SessionAttributes;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.net.URLDecoder;
import java.util.*;

/**
 * Created by llh on 2017/5/9.
 */
@RestController
@RequestMapping("/tjDimensionMain")
public class TjDimensionMainController extends EnvelopRestEndpoint {

    @Autowired
    TjDimensionMainService tjDimensionMainService;

    //查询统计主维度
    @RequestMapping("/getTjDimensionMain")
    public Object searchTjDimensionMain(String name, int page, int rows){
        String url = "/tj/getTjDimensionMainList";
        String resultStr = "";
        Envelop envelop = new Envelop();
        Map<String, Object> params = new HashMap<>();
        StringBuffer stringBuffer = new StringBuffer();
        if (!StringUtils.isEmpty(name)) {
            stringBuffer.append("name?" + name );
        }
        String filters = stringBuffer.toString();
        if (!StringUtils.isEmpty(filters)) {
            params.put("filters", filters);
        }
        params.put("page", page);
        params.put("size", rows);
        try {
            PageEnvelop PageEnvelop = new PageEnvelop();
            List<TjDimensionMain> qtjDimensionMainList = tjDimensionMainService.search(null, filters, null, page, rows);
            if(qtjDimensionMainList != null){
                PageEnvelop.setDetailModelList(qtjDimensionMainList);
                PageEnvelop.setTotalCount((int)tjDimensionMainService.getCount(filters));
                PageEnvelop.setStatus(200);
                PageEnvelop.setCurrPage(page);
                PageEnvelop.setPageSize(rows);
            }else{
                PageEnvelop.setStatus(200);
                PageEnvelop.setMessage("查询无数据");
                PageEnvelop.setTotalCount(0);
            }
            return PageEnvelop;
        } catch (Exception ex) {
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }



    /**
     * 新增修改
     * @param tjDimensionMainModelJsonData
     * @param request
     * @return
     * @throws IOException
     */
    @RequestMapping(value = "updateTjDimensionMain", produces = "text/html;charset=UTF-8")
    public Object updateTjDimensionMain(String tjDimensionMainModelJsonData, HttpServletRequest request) throws IOException {

        String url = "/tj/tjDimensionMain";
        String resultStr = "";
        System.out.println();
        String[] strings = URLDecoder.decode(tjDimensionMainModelJsonData, "UTF-8").split(";");
        TjDimensionMain detailModel = objectMapper.readValue(strings[0], TjDimensionMain.class);
        try {
            if (!StringUtils.isEmpty(detailModel.getId())) {
                Long id = detailModel.getId();
                TjDimensionMain updateTjDimensionMain = tjDimensionMainService.getTjDimensionMain(id);
                if (updateTjDimensionMain!=null) {
                    updateTjDimensionMain.setCode(detailModel.getCode());
                    updateTjDimensionMain.setName(detailModel.getName());
                    updateTjDimensionMain.setType(detailModel.getType());
                    updateTjDimensionMain.setStatus(detailModel.getStatus());
                    updateTjDimensionMain.setRemark(detailModel.getRemark());
                    updateTjDimensionMain.setUpdateTime(new Date());
                    tjDimensionMainService.save(updateTjDimensionMain);
                    return ObjEnvelop.getSuccess("保存成功",updateTjDimensionMain);
                } else {
                    return failed("参数错误");
                }
            } else {
                detailModel.setCreateTime(new Date());
                tjDimensionMainService.save(detailModel);
                return ObjEnvelop.getSuccess("保存成功",detailModel);
            }
        } catch (Exception e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    /**
     * 删除消息
     * @param tjDimensionMainId
     * @return
     */
    @RequestMapping("deleteTjDimensionMain")
    public Object deleteTjDimensionMain(Long tjDimensionMainId) {
        String url = "/tj/tjDimensionMain";

        try {
            TjDimensionMain tjDimensionMain = tjDimensionMainService.getTjDimensionMain(tjDimensionMainId);
            tjDimensionMain.setStatus(-1);
            tjDimensionMainService.save(tjDimensionMain);
            return ObjEnvelop.getSuccess("主维度删除成功！");
        } catch (Exception e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }


    /**
     * 根据id获取消息
     * @param id
     * @return
     */
    @RequestMapping("getTjDimensionMainByID")
    public Envelop getTjDimensionMainByID(Long id ) {
        String url ="/tj/tjDimensionMainId/" +id;
        try {
            TjDimensionMain updateTjDimensionMain = tjDimensionMainService.getTjDimensionMain(id);
            return ObjEnvelop.getSuccess("查询成功",updateTjDimensionMain);
        } catch (Exception e) {
            e.printStackTrace();
            return failed("查询失败");
        }
    }



    /**
     * 校验名称是否唯一
     * @param name
     * @return
     */
    @RequestMapping("isNameExists")
    public Envelop isNameExists(String name) {
        String url = "/tj/tjDimensionMainName" ;
        try {
            String filter = "name=" + name;
            List<TjDimensionMain> tjDimensionMains = tjDimensionMainService.search(filter);
            return ObjEnvelop.getSuccess("",tjDimensionMains.size() >0);
        } catch (Exception e) {
            e.getMessage();
        }
        return  failed("查询失败");
    }

    /**
     * 校验code是否唯一
     * @param code
     * @return
     */
    @RequestMapping("isCodeExists")
    public Envelop isCodeExists(String code) {
        String url = "/tj/tjDimensionMainCode" ;
        try {
            String filter = "code=" + code;
            List<TjDimensionMain> tjDimensionMains = tjDimensionMainService.search(filter);
            return ObjEnvelop.getSuccess("",tjDimensionMains.size() >0);
        } catch (Exception e) {
            e.getMessage();
        }
        return  failed("查询失败");
    }

//    @RequestMapping("/getTjDimensionMainInfo")
//    public Envelop getTjDimensionMainInfo(String quotaCode, String name, int page, int rows){
//        String url = "/tj/getTjDimensionMainInfoList";
//        String resultStr = "";
//        Envelop envelop = new Envelop();
//        Map<String, Object> params = new HashMap<>();
//        StringBuffer mainFilter = new StringBuffer("status=1");
//        if (!StringUtils.isEmpty(quotaCode)) {
//            params.put("filter", "quotaCode=" + quotaCode);
//        }
//        if (!StringUtils.isEmpty(name)) {
//            mainFilter.append("name?" + name + " g1;code?" + name + " g1;");
//        }
//        String filters = mainFilter.toString();
//        if (!StringUtils.isEmpty(filters)) {
//            params.put("filters", filters);
//        }
//        params.put("page", page);
//        params.put("size", rows);
//        try {
//            ListResult listResult = tjDimensionMainClient.search(fields, filters, sorts, size, page);
//
//            List<TjDimensionMainModel> mainModelList  = new ArrayList<>();
//            if(listResult.getTotalCount() != 0){
//                List<Map<String,Object>> modelList = listResult.getDetailModelList();
//                for(Map<String,Object> map : modelList){
//                    TjDimensionMainModel tjDimensionMainModel = objectMapper.convertValue(map,TjDimensionMainModel.class);
//                    mainModelList.add(tjDimensionMainModel);
//                }
//                ListResult listResult2 = tjQuotaDimensionMainClient.search(fields, filter, sorts, size, page);
//                List<TjQuotaDimensionMainModel> mainModelList2  = new ArrayList<>();
//                if(listResult2.getTotalCount() != 0) {
//                    List<Map<String, Object>> modelList2 = listResult2.getDetailModelList();
//                    for (Map<String, Object> map : modelList2) {
//                        TjQuotaDimensionMainModel tjQuotaDimensionMainModel = objectMapper.convertValue(map, TjQuotaDimensionMainModel.class);
//                        TjDimensionMain tjDimensionMain = tjDimensionMainClient.getTjDimensionMain(tjQuotaDimensionMainModel.getMainCode());
//                        if (tjDimensionMain != null) {
//                            tjQuotaDimensionMainModel.setName(tjDimensionMain.getName());
//                        }
//                        mainModelList2.add(tjQuotaDimensionMainModel);
//                    }
//                }
//                List<String> list = getTjQuotaDimensionMainOfMainCode(filter, sorts);
//                for (int i=0; i<mainModelList.size(); i++) {
//                    if (list.contains(mainModelList.get(i).getCode())) {
//                        mainModelList.get(i).setChecked(true);
//                    } else {
//                        mainModelList.get(i).setChecked(false);
//                    }
//                }
//                Envelop result = getResult(mainModelList, listResult.getTotalCount(), listResult.getCurrPage(), listResult.getPageSize());
//                result.setObj(mainModelList2);
//                return result;
//            }else{
//                Envelop envelop = new Envelop();
//                return envelop;
//            }
//        } catch (Exception ex) {
//            ex.printStackTrace();
//            return failed(ERR_SYSTEM_DES);
//        }
//    }
}
