package com.yihu.jw.basic.agadmin.controller.resource;

import com.yihu.jw.basic.resource.service.RsMetadataService;
import com.yihu.jw.basic.resource.service.RsResourceMetadataService;
import com.yihu.jw.entity.ehr.id.BizObject;
import com.yihu.jw.entity.ehr.resource.RsMetadata;
import com.yihu.jw.entity.ehr.resource.RsResourceMetadata;
import com.yihu.jw.restmodel.ehr.resource.MRsMetadata;
import com.yihu.jw.restmodel.ehr.resource.MRsResourceMetadata;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.util.http.HttpClientUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.domain.Page;
import org.springframework.ui.Model;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import java.util.*;

/**
 * 资源配置服务控制器
 * Created by wq on 2016/5/23.
 */
@RestController
@RequestMapping("/resourceConfiguration")
public class ResourceConfigurationController extends EnvelopRestEndpoint {

    @Autowired
    private RsResourceMetadataService rsMetadataService;
    @Autowired
    private RsMetadataService metadataService;

    @RequestMapping("searchResourceConfiguration")
    public Object searchResourceConfiguration(String searchNm, int page, int rows) {
        Map<String, Object> params = new HashMap<>();
        String metaDataUrl = "/resources/metadata";
        String resultStr = "";
        params.put("filters", "");
        String filters ="valid=1";
        if (!StringUtils.isEmpty(searchNm)){
            filters += ";name?" + searchNm + " g1;id?" + searchNm + " g1";
        }
        params.put("filters",filters);
        params.put("page", page);
        params.put("size", rows);
        params.put("fields", "");
        params.put("sorts", "");
        try {
            long total = 0;
            List<MRsMetadata> metaList;

            //过滤条件为空
            if(StringUtils.isEmpty(filters))
            {
                Page<RsMetadata> metadataPage = metadataService.getMetadata(null,reducePage(page),rows);
                total = metadataPage.getTotalElements();
                return PageEnvelop.getSuccessListWithPage("查询成功",metadataPage.toList(),page,rows,total);
            }
            else
            {
                List<RsMetadata> metadata = metadataService.search(null,filters,null,page,rows);
                total = metadataService.getCount(filters);
                return PageEnvelop.getSuccessListWithPage("查询成功",metadata,page,rows,total);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return failed("查询失败");

    }

    @RequestMapping("searchSelResourceConfiguration")
    public Object searchSelResourceConfiguration(String searchNm, String resourcesId, int page, int rows) {
        Map<String, Object> params = new HashMap<>();
        String ResourceMetadataUrl = "/resources/rs_metadata";
        String selResourceMetadataListUrl = "/resources/" + resourcesId + "/metadata_list";
        String resultStr = "";
        try {
            if (searchNm.equals("selAll")) {
//                resultStr = HttpClientUtil.doGet(comUrl + selResourceMetadataListUrl, params, username, password);
            } else {
                String filters = "";
                params.put("filters", "");
                if (!StringUtils.isEmpty(searchNm)) {
                    filters = "name?" + searchNm + " g1;id?" + searchNm + " g1";
                }
                params.put("resources_id", "");
                if (!StringUtils.isEmpty(resourcesId)) {
                    params.put("resources_id", resourcesId);
                }
                params.put("page", page);
                params.put("size", rows);
                params.put("fields", "");
                params.put("sorts", "");
                long total = 0;
                //过滤条件为空
                if (StringUtils.isEmpty(filters)) {
                    Page<RsResourceMetadata> dimensions = rsMetadataService.getResourceMetadata(null, reducePage(page), rows);
                    total = dimensions.getTotalElements();
                    return PageEnvelop.getSuccessListWithPage("查询成功",dimensions.toList(),page,rows,total);
                } else {
                    List<RsResourceMetadata> dimensions = rsMetadataService.search(null, filters, null, page, rows);
                    total = rsMetadataService.getCount(filters);
                    return PageEnvelop.getSuccessListWithPage("查询成功",dimensions,page,rows,total);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return resultStr;

    }

    @RequestMapping("/saveResourcConfiguration")
    public Envelop saveResourceConfiguration(String addRowDatas, String delRowDatas) {
        Map<String, Object> params = new HashMap<>();
        String resultStr = "";
        String metaDataUrl = "/resources/rs_metadata/batch";
        try {
            if (!StringUtils.isEmpty(delRowDatas)) {
                //执行删除操作
                rsMetadataService.delete(delRowDatas);
                return success("删除成功");
            }
            if (!StringUtils.isEmpty(addRowDatas)) {
                //执行新增操作
                RsResourceMetadata[] rsMetadata = toEntity(addRowDatas, RsResourceMetadata[].class);
                for (RsResourceMetadata metadata : rsMetadata) {
                    metadata.setId(getObjectId(BizObject.ResourceMetadata));
                }
                List<RsResourceMetadata> metadataList = rsMetadataService.saveMetadataBatch(rsMetadata);
                return success("新增成功");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return failed("操作失败");
    }
}